<template>
  <div class="app-container">
    <!-- <el-form
      :model="queryParams"
      ref="queryForm"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <el-form-item>
        <el-button
          type="primary"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
          >重置</el-button
        >
      </el-form-item>
    </el-form> -->

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5"><el-button type="primary" icon="el-icon-plus" @click="handleAdd" v-hasPermi="['management:record:add']">新增</el-button></el-col>
      <el-col :span="1.5"><el-button type="success" icon="el-icon-edit" :disabled="single" @click="handleUpdate" v-hasPermi="['management:record:edit']">修改</el-button></el-col>
      <el-col :span="1.5">
        <el-button type="danger" icon="el-icon-delete" :disabled="multiple" @click="handleDelete" v-hasPermi="['management:record:remove']">删除</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" border :data="recordList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="店铺名称" align="center" prop="shopName" />
      <el-table-column label="销售时间" align="center" prop="salesTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.salesTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="散客预约人数" align="center" prop="scatteredAppointment" />
      <el-table-column label="散客接待人数" align="center" prop="scatteredReception" />
      <el-table-column label="团客预约人数" align="center" prop="groupAppointment" />
      <el-table-column label="团客接待人数" align="center" prop="groupReception" />
      <el-table-column label="销售金额" align="center" prop="salesAmount" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)" v-hasPermi="['management:record:edit']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)" v-hasPermi="['management:record:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize" @pagination="getList" />

    <!-- 添加或修改店铺销售记录对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="50%" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="店铺" prop="shopId">
          <el-select v-if="shopList" v-model="form.shopId">
            <el-option v-for="(item, index) in shopList" :key="'shop' + index" :label="item.name" :value="item.shopId"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="销售时间" prop="salesTime">
          <el-date-picker clearable size="small" v-model="form.salesTime" type="date" value-format="yyyy-MM-dd" placeholder="选择销售时间"></el-date-picker>
        </el-form-item>
        <el-form-item label="散客预约人数" prop="scatteredAppointment">
          <el-input-number v-model="form.scatteredAppointment" :min="0" placeholder="请输入散客预约人数" />
        </el-form-item>
        <el-form-item label="散客接待人数" prop="scatteredReception"><el-input-number v-model="form.scatteredReception" :min="0" placeholder="请输入散客接待人数" /></el-form-item>
        <el-form-item label="团客预约人数" prop="groupAppointment"><el-input-number v-model="form.groupAppointment" :min="0" placeholder="请输入团客预约人数" /></el-form-item>
        <el-form-item label="团客接待人数" prop="groupReception"><el-input-number v-model="form.groupReception" :min="0" placeholder="请输入团客接待人数" /></el-form-item>
        <el-form-item label="销售金额" prop="salesAmount"><el-input-number v-model="form.salesAmount" :min="0" :precision="2" placeholder="请输入销售金额" /></el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listRecord, getRecord, delRecord, addRecord, updateRecord, exportRecord } from '@/api/management/record';
import { shopSelect } from '@/api/management/shop';
export default {
  name: 'Record',
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 店铺销售记录表格数据
      recordList: [],
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        orderByColumn: 'createTime', //排序字段
        isAsc: 'desc' //排序方式
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        shopId: [{ required: true, message: '请选择店铺' }],
        salesTime: [{ required: true, message: '请选择销售时间' }],
        scatteredAppointment: [{ required: true, message: '请输入散客预约人数' }],
        scatteredReception: [{ required: true, message: '请输入散客接待人数' }],
        groupAppointment: [{ required: true, message: '请输入团客预约人数' }],
        groupReception: [{ required: true, message: '请输入团客接待人数' }],
        salesAmount: [{ required: true, message: '请输入销售金额' }]
      },
      shopList: []
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询店铺销售记录列表 */
    getList() {
      this.loading = true;
      listRecord(this.queryParams).then(response => {
        this.recordList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        shopSalesRecordId: null,
        shopId: null,
        salesTime: null,
        scatteredAppointment: null,
        scatteredReception: null,
        groupAppointment: null,
        groupReception: null,
        salesAmount: null,
        createTime: null
      };
      this.resetForm('form');
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm');
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.shopSalesRecordId);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = '添加店铺销售记录';
      this.getShopList();
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.getShopList();
      const shopSalesRecordId = row.shopSalesRecordId || this.ids;
      getRecord(shopSalesRecordId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = '修改店铺销售记录';
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs['form'].validate(valid => {
        if (valid) {
          if (this.form.shopSalesRecordId != null) {
            updateRecord(this.form).then(response => {
              this.msgSuccess('修改成功');
              this.open = false;
              this.getList();
            });
          } else {
            addRecord(this.form).then(response => {
              this.msgSuccess('新增成功');
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const shopSalesRecordIds = row.shopSalesRecordId || this.ids;
      this.$confirm('是否确认删除店铺销售记录编号为"' + shopSalesRecordIds + '"的数据项?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      })
        .then(function() {
          return delRecord(shopSalesRecordIds);
        })
        .then(() => {
          this.getList();
          this.msgSuccess('删除成功');
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有店铺销售记录数据项?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      })
        .then(() => {
          this.exportLoading = true;
          return exportRecord(queryParams);
        })
        .then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        })
        .catch(() => {});
    },
    getShopList() {
      shopSelect().then(res => {
        this.shopList = res.rows;
      });
    }
  }
};
</script>
